/*
	A basic example of an NPC whose dialogue follows a Chain.
	see TellListNPC.dm for a more compact version of this.
*/

world
	New()
		..()
		new/mob/npc/Chain(locate(4, 3, 1))

mob/npc/Chain
	DialogueStart(mob/player/player)
		// Starting line is the Chain defined below.
		return new.dialogue_chain

	dialogue_chain
		parent_type = /dialogue/chain

		New()
			// First Link in the Chain, defined below.
			..(new.links/First)

		links
			// These are all Links in the Chain.
			parent_type = /dialogue/chain/link

			First
				Action(mob/npc/npc, mob/player/player)
					npc.Tell(player, "First...")

				Next(mob/npc/npc, mob/player/player)
					// The Second line comes next.
					return new.Second

			Second
				Action(mob/npc/npc, mob/player/player)
					npc.Tell(player, "Second..")

				Next(mob/npc/npc, mob/player/player)
					// The Third line comes next.
					return new.Third

			Third
				Action(mob/npc/npc, mob/player/player)
					npc.Tell(player, "Third.")

				Next(mob/npc/npc, mob/player/player)
					// The Last line comes next.
					return new.Last

			Last
				Action(mob/npc/npc, mob/player/player)
					npc.Tell(player, "Last!")

				Next(mob/npc/npc, mob/player/player)
					// Loop back to itself.
					return src
