/*
	Goes through a list of things to tell the player.
	After comes after all things have been told.
	It defaults to repeating the last thing that was said.

	This is a generalization of the Chain NPC's Dialogue Chain.
*/
dialogue/chain/link/tells
	var
		list/tells
		index = 1

	New(list/tells)
		if(tells)
			src.tells = tells

	Action(mob/npc/npc, mob/player/player)
		npc.Tell(player, tells[index])

	Next(mob/npc/npc, mob/player/player)
		// If possible, move to the next Tell and return src.
		// Otherwise move on to the Link After.
		if(index < tells.len)
			index++
			return src
		else
			return After(npc, player)

	proc
		After(mob/npc/npc, mob/player/player)
			// Return the Link that comes After the final Tell.
			return src
