mob/npc
	proc
		DialogueStart(mob/player/player)
			// Return a /dialogue/line for the start of this NPC's dialogue.

mob/player
	var
		// This associates NPC names to the current Dialogue Line they're at.
		// Each player needs their own version of each NPC's dialogue.
		list/npc_dialogues

	proc
		TalkTo(mob/npc/npc)
			// Execute the Action of the Dialogue Line for this NPC.
			GetNpcDialogue(npc).Action(npc, src)

		GetNpcDialogue(mob/npc/npc)
			if(!npc_dialogues)
				// Lazy-initialize the dialogue storage.
				npc_dialogues = new

			var id = GetNpcId(npc)
			if(!npc_dialogues[id])
				// Initialize the dialogue for this NPC.
				npc_dialogues[id] = npc.DialogueStart(src)

			return npc_dialogues[id]

		GetNpcId(mob/npc/npc)
			// Return a unique non-numeric identifier used to associate dialogues to NPCs.
			return npc.name

dialogue/line
	// A Line of dialogue has an Action (e.g. the NPC tells the player some text).
	proc
		Action(mob/npc/npc, mob/player/player)
			// Do something, maybe.

dialogue/chain
	// A Chain is a Line that iterates over Links.
	parent_type = /dialogue/line

	var
		dialogue/chain/link/current

	New(dialogue/chain/link/start)
		if(start)
			current = start

	Action(mob/npc/npc, mob/player/player)
		// A Chain's Action is the current Link's Action followed by moving to the current Link's Next Link.
		current.Action(npc, player)
		current = current.Next(npc, player)

	link
		// A Link is a Line that is followed by the Next Link in a Chain.
		parent_type = /dialogue/line

		proc
			Next(mob/npc/npc, mob/player/player)
				// Return a line.
